<?php
/**
 * Tagcloud
 * @package Joomla!
 * @Copyright (C) 2012 - Yves Hoppe - compojoom.com
 * @All rights reserved
 * @Joomla! is Free Software
 * @Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
 * @version $Revision: 0.9.0 beta $
 **/
require_once (JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');

class modCTagcloudHelper
{
    private static $instance;

    /* cleanText function - Thx owed to eXtplorer, joomSEO and Jean-Marie Simonet */
    public static function cleanText($text)
    {
        $text = preg_replace("'<script[^>]*>.*?</script>'si", '', $text);
        $text = preg_replace('/<!--.+?-->/', '', $text);
        $text = preg_replace('/{.+?}/', '', $text);

        // convert html entities to chars (with conditional for PHP4 users
        if ((version_compare(phpversion(), '5.0') < 0)) {
            require_once(JPATH_SITE . DS . 'libraries' . DS . 'tcpdf' . DS . 'html_entity_decode_php4.php');
            $text = html_entity_decode_php4($text, ENT_QUOTES, 'UTF-8');
        } else {
            $text = html_entity_decode($text, ENT_QUOTES, 'UTF-8');
        }

        $text = strip_tags($text); // Last check to kill tags
        $text = str_replace('"', '\'', $text); //Make sure all quotes play nice with meta.
        $text = str_replace(array("\r\n", "\r", "\n", "\t"), " ", $text); //Change spaces to spaces

        // remove any extra spaces
        while (strchr($text, "  ")) {
            $text = str_replace("  ", " ", $text);
        }

        // general sentence tidyup
        for ($cnt = 1; $cnt < strlen($text); $cnt++) {
            // add a space after any full stops or comma's for readability
            // added as strip_tags was often leaving no spaces
            if (($text{$cnt} == '.') || (($text{$cnt} == ',') && !(is_numeric($text{$cnt + 1})))) {

                // WTF?!!! I hate copying code
                /*if ($text{$cnt+1} != ' ') {
                    $text = substr_replace($text, ' ', $cnt + 1, 0);
                }*/
            }
        }

        return $text;
    }


    /**
     * @static
     * @param int $ec
     * @param null $cat
     * @param bool $random
     * @return array|null
     */
    public static function loadElements($ec = 40, $cat = null, $random = false)
    {
        $db =& JFactory::getDBO();

        $cat_id = null;

        // Get the section id
        if ($cat != null) {
            $query = 'SELECT id FROM #__categories WHERE alias = ' . $cat
                . ' AND published = 1';

            $db->setQuery($query);

            $cat_id = $db->loadObject()->id;
        }

        $query = 'SELECT * FROM #__content WHERE publish_up < "' . date_format(new DateTime(),
            'Y-m-d H:i:s') . '" AND access = 1 AND state = 1 ORDER BY hits DESC LIMIT ' . $ec;


        if ($cat_id != null) {
            $query = 'SELECT * FROM #_content WHERE catidd = ' . $cat_id
                . ' AND publish_up < "' . date_format(new DateTime(),
                'Y-m-d H:i:s') . '" AND access = 1 AND state = 1 ORDER BY hits DESC';
        }

        $db->setQuery($query);
        $dbele = $db->loadObjectList();

        $elements = array();

        if (empty($dbele)) {
            return null;
        }

        // Calculate if we have enough elements to use every content item only once ($ec different links)
        $count_per_element = count($dbele) / $ec;

        if ($count_per_element >= 1) {
            // Nice this is easy :)
            for ($i = 0; $i < count($dbele); $i++) {
                $ele = $dbele[$i];

                $tmp = new TagcloudElement();

                // Set element id
                $tmp->setId($ele->id);

                // Create the link
                $tmp->setLink(ContentHelperRoute::getArticleRoute($ele->id));

                // Take Title from the document
                $txt = substr($ele->title, 0, 19); // substr to param?!
                $tmp->setText($txt);

                // Generate a clean title from the fulltext and take the chars 0-50
                $title = substr(modCTagcloudHelper::cleantext($ele->fulltext), 0, 50);

                $tmp->setTitle($title);

                $elements[] = $tmp;
            }
        } else {
            // If we have less elements then ..
            // we just take as much as we have.. could be improved later
            for ($i = 0; $i < count($dbele); $i++) {
                $ele = $dbele[$i];

                $tmp = new TagcloudElement();

                // Set element id
                $tmp->setId($ele->id);

                // Create the link
                $tmp->setLink(ContentHelperRoute::getArticleRoute($ele->id));

                // Take Title from the document
                $txt = substr($ele->title, 0, 19); // substr to param?!
                $tmp->setText($txt);

                // Generate a clean title from the fulltext and take the chars 0-50
                $title = substr(modCTagcloudHelper::cleantext($ele->fulltext), 0, 50);

                $tmp->setTitle($title);

                $elements[] = $tmp;
            }
        }

        if($random){
            shuffle($elements);
        }

        return $elements;
    }

    /**
     * @static
     * @param array|TagcloudElement $elements
     * @param array $options
     * @return array|null
     */
    public static function getStyledElements($elements, $options =
    array("startfontsize" => 6, "endfontsize" => 20, "color" => null))
    {

        $styled_elements = null;

        for ($i = 0; $i < count($elements); $i++) {
            $ele = $elements[$i];

            // TODO Important elements are first and should get a higher font size :)

            $ele->fontsize = rand($options['startfontsize'], $options['endfontsize']);

            if(!empty($options['color'])) {
                $gc = rand($options['color'] - 15, $options['color'] + 15);

                $ele->fontcolor = modCTagcloudHelper::generateColor($gc);
            }

            // Irgendwann
            //$ele->hovercolor = "";
            //$ele->hoversize = rand($options['startfontsize'], $options['endfontsize']);
            $styled_elements[] = $ele;
        }

        return ($styled_elements);
    }

    /**
     * TODO Improve this
     * @static
     * @param $value
     * @return stdClass
     */
    public static function generateColor($value)
    {
        // Make a param some time :)
        $range = 100;
        $rangeLower = 60;
        $rangeHeight = 100;

        // generate color based on value between 0 and 100
        // closer the number, more similar the colors. 0 is red. 50 is green. 100 is blue.
        $color_range = $range / 3;
        $color = new stdClass();
        $color->red = $rangeLower;
        $color->green = $rangeLower;
        $color->blue = $rangeLower;
        if ($value < $color_range * 1) {
            $color->red += $color_range - $value;
            $color->green += $value;
        } else if ($value < $color_range * 2) {
            $color->green += $color_range - $value;
            $color->blue += $value;
        } else if ($value < $color_range * 3) {
            $color->blue += $color_range - $value;
            $color->red += $value;
        }
        // returns color object with properties red green and blue.
        $htmlcolor = modCTagcloudHelper::rgba2html($color->red, $color->green, $color->blue);

        return $htmlcolor;
    }


    /**
     * @static
     * @param $r
     * @param $g
     * @param $b
     * @param $a
     * @return string
     */
    public static function rgba2html($r, $g=-1, $b=-1, $a=-1)
    {
        if (is_array($r) && sizeof($r) == 3)
            list($r, $g, $b) = $r;

        $r = intval($r); $g = intval($g);
        $b = intval($b);

        $r = dechex($r<0?0:($r>255?255:$r));
        $g = dechex($g<0?0:($g>255?255:$g));
        $b = dechex($b<0?0:($b>255?255:$b));
        if($a != -1)
            $a = dechex($a<0?0:($a>255?255:$a));

        $color = "";

        if($a != -1) {
            // echo $a;
            if($a == 0){
                $color .= "00";
            } else if( $a == 1) {

            } else {
                $color .= (strlen($a) < 2?'0':'').$a;
            }
        }

        $color .= (strlen($r) < 2?'0':'').$r;
        $color .= (strlen($g) < 2?'0':'').$g;
        $color .= (strlen($b) < 2?'0':'').$b;

        // echo "COLOR: " . $color;
        return '#'.$color;
    }

    /**
     * @static
     * @param $ele
     * @return string
     */
    public static function getAElementStyle($ele)
    {
        $style = "";

        if (!empty($ele->fontsize)) {
            $style .= "font-size: " . $ele->fontsize . "px;";
        }

        if (!empty($ele->fontcolor)) {
            $style .= "color: " . $ele->fontcolor . ";";
        }

        return $style;
    }

}


/**
 * Tag Element Class
 */
class TagcloudElement
{

    public $_id = 0;
    public $_title = 0;
    public $_text;
    public $_link;

    public $_fontsize = 12;
    public $_fontcolor = null;

    public $_hoversize = 12;
    public $_hovercolor = null;

    public $_orientation = 'horizontal';

    public function setFontcolor($fontcolor)
    {
        $this->_fontcolor = $fontcolor;
    }

    public function getFontcolor()
    {
        return $this->_fontcolor;
    }

    public function setFontsize($fontsize)
    {
        $this->_fontsize = $fontsize;
    }

    public function getFontsize()
    {
        return $this->_fontsize;
    }

    public function setId($id)
    {
        $this->_id = $id;
    }

    public function getId()
    {
        return $this->_id;
    }

    public function setLink($link)
    {
        $this->_link = $link;
    }

    public function getLink()
    {
        return $this->_link;
    }

    public function setOrientation($orientation)
    {
        $this->_orientation = $orientation;
    }

    public function getOrientation()
    {
        return $this->_orientation;
    }

    public function setText($text)
    {
        $this->_text = $text;
    }

    public function getText()
    {
        return $this->_text;
    }

    public function setTitle($title)
    {
        $this->_title = $title;
    }

    public function getTitle()
    {
        return $this->_title;
    }
}