<?php
/**
 * Tiles
 * @package Joomla!
 * @Copyright (C) 2012 - Yves Hoppe - compojoom.com
 * @All rights reserved
 * @Joomla! is Free Software
 * @Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
 * @version $Revision: 0.9.0 beta $
 **/

defined('_JEXEC') or die;

JHTML::_('stylesheet', 'template.css', 'media/mod_ctagcloud/templates/compojoom/');
JHTML::_('script', 'templates.js', 'media/mod_ctagcloud/templates/compojoom/');

$elements = modCTagcloudHelper::loadElements($params->get('module_element_number', '40'), $params->get('category', null),
    $params->get('random', false));

if(empty($elements)){
    JError::raise('500', 'MOD_TAGCLOUD_NO_TAGS');
    return;
}

// Style the elements
// $options = array("startfontsize" => 6, "endfontsize" => 20, "color" => null)
$style_options = array("startfontsize" => $params->get('startfontsize', '6'),
    "endfontsize" => $params->get('endfontsize', '20'),
    "color" => $params->get("color", null));

$styled_elements = modCTagcloudHelper::getStyledElements($elements, $style_options);

$doc = & JFactory::getDocument();

$domready = "window.addEvent('domready', function(){ \n";
$domready .= "});";

$doc->addScriptDeclaration($domready);

$font = $params->get('font', 0);
$csscode = "";

/*
 * TODO move into funtion
 * <option value="0">MOD_TAGCLOUD_FONT_NONE</option>
                    <option value="1">MOD_TAGCLOUD_GOOGLE_FONT_RUSSO_ONE</option>
                    <option value="2">MOD_TAGCLOUD_GOOGLE_FONT_AUDOWIDE</option>
                    <option value="3">MOD_TAGCLOUD_GOOGLE_FONT_PONTANO_SANS</option>
                    <option value="4">MOD_TAGCLOUD_GOOGLE_FONT_CONDIMENT</option>
                    <option value="5">MOD_TAGCLOUD_GOOGLE_FONT_COMPOJOOM</option>
                    <!--LOBSTER-->
                    <option value="6">MOD_TAGCLOUD_FONT_CUSTOM</option>
 */

if($font != 0) {
    switch($font){
        case 1:
            $doc->addStyleSheet("http://fonts.googleapis.com/css?family=Russo+One");
            $csscode = ".tagcloud_a {font-family: 'Russo One', sans-serif;}";
            break;

        case 2:
            $doc->addStyleSheet("http://fonts.googleapis.com/css?family=Audiowide");
            $csscode = ".tagcloud_a {font-family: 'Audiowide', cursive;}";
            break;

        case 3:
            $doc->addStyleSheet("http://fonts.googleapis.com/css?family=Pontano+Sans");
            $csscode = ".tagcloud_a {font-family: 'Pontano Sans', sans-serif;}";
            break;

        case 4:
            $doc->addStyleSheet("http://fonts.googleapis.com/css?family=Condiment");
            $csscode = ".tagcloud_a {font-family: 'Condiment', cursive;}";
            break;

        case 5:
            $doc->addStyleSheet("http://fonts.googleapis.com/css?family=Lobster");
            $csscode = ".tagcloud_a {font-family: 'Lobster', cursive;}";
            break;

        case 6:
            $csscode = $params->get('customfont', '');
            break;

    }
}

$doc->addStyleDeclaration($csscode);

// Generated CSS
?>
<style type="text/css">

</style>

<?php /* Starting tagcloud */ ?>
<div id="tagcloud_holder">
    <?php
    $nofollow = "";
    if($params->get('nofollow', false)){
        $nofollow = "rel=\"nofollow\"";
    }
    for($i = 0; $i < count($elements); $i++){
        $ele = $elements[$i];
        $style = modCTagcloudHelper::getAElementStyle($ele);

        echo "<a href=\"" . $ele->getLink() . "\" title=\"" . $ele->getTitle() . "\" class=\"tagcloud_a\" "
            . $nofollow . " style=\"" . $style . "\">";
        echo $elements[$i]->getText();
        echo "</a>\n";
    }
    ?>
</div>